/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package semestralka;

import java.util.Random;

/**
 *
 * @author Radek Hubner
 */
public class Mesto {

    private int x;
    private int y;
    private int baterka;
    private Smer smer;
    private static int x2;
    private static int y2;
    private static int s2;
    private int chyba;
    Random nahoda = new Random();

    static {
        x2 = -1;
        y2 = -1;
        s2 = 0;
    }

    public Mesto() {
    }

    /**
     * Vytvori nahodnou instanci mesta po ktere se muze robot pohybovat
     * @return
     */
    public static synchronized Mesto getInstance() {
        Mesto m = new Mesto();
        Random r = new Random();

        m.x = x2;
        m.y = x2;
        m.smer = Smer.nahoda(s2); //generujeme pouze kladna cisla
        m.baterka = 100;
        m.chyba = 3;
        return m;
    }

    private static void posunGenerovani() {
        s2++;
        if (s2 > Smer.values().length) {
            s2 = 0;
            x2++;
            if (x2 > 16) {
                x2 = -16;
                y2++;
                if (y2 > 16) {
                    y2 = -16;
                }
            }
        }
    }

    public Robot prikaz(Prikaz p, Integer... blok) {
        switch (p) {
            case KROK:
                baterka -= 10;
                return krok();
            case VLEVO:
                baterka -= 10;
                return vlevo();
            case ZVEDNI:
                return zvedni();
            case NABIT:
                baterka = 1;    //pokud nastane chyba pri nabije je potreba dat baterku na 1
                chyba();        //pokud nehodi exception tak je vse OK. Jinak nastala porucha
                baterka = 100;
                return new Robot(x, y, baterka);
            case OPRAVIT:
                if (blok[0] == -1 * chyba) {
                    chyba = nahoda.nextInt(5) + 3;
                    return new Robot(x, y, baterka);
                } else {
                    throw new NoErrorException();
                }
        }
        return null;
    }

    private Robot vlevo() {        
        smer = smer.vlevo();        
        return new Robot(x, y, baterka);
    }

    private void chyba() {
        if (chyba > 0) {
            chyba -= 1;
        }else if (chyba == 0) {
            chyba = -1 * (nahoda.nextInt(8) + 1); //eliminujeme nulu
            throw new RobotErrorException(chyba * -1);
        } else {
            throw new RobotCrashException();
        }
    }

    private Robot krok() {
        chyba();
        switch (smer) {
            case JIH:
                this.y--;
                break;
            case SEVER:
                this.y++;
                break;
            case ZAPAD:
                this.x--;
                break;
            case VYCHOD:
                this.x++;
                break;
        }
        return new Robot(x, y, baterka);
    }

    private Robot zvedni() {
        if (this.x == 0 && this.y == 0) {
            return new Robot("Seru na palindrom");
        } else {
            throw new ZnackaNenalezena("znacka tu neni :D");
        }
    }
}
