/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package semestralka;

import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author Radek Hubner
 */
public class ServerClient extends Thread {

    private static final String OSLOVENI = "karel";
    private Socket sok;
    private FuckingBufferedReader in;
    private PrintWriter out;
    private Pattern p = null;
    private Mesto mesto = Mesto.getInstance();

    public ServerClient(String name, Socket sok) {
        super(name);
        this.sok = sok;
        String pattern = "^" + OSLOVENI + " (?:(KROK|VLEVO|ZVEDNI|NABIT)|(?:(OPRAVIT) (\\d)))";
        p = Pattern.compile(pattern);
    }

    private void init() throws Exception {
        in = new FuckingBufferedReader(new InputStreamReader(sok.getInputStream()));
        out = new PrintWriter(sok.getOutputStream());
        out.write("220 Oslovuj mne " + OSLOVENI + ".");
        zapisKonecRadku();
    }

    @Override
    public void run() {
        try {
            init();
        } catch (Exception ex) {
            close();
            return;     //pokud nastane vyjimka koncime
        }
        String prikaz = null;
        do {
            prikaz = in.readLine();
        } while (zpracujPrikaz(prikaz));
        close();
    }

    /**
     * Zpracuje zadany prikaz, zaroven posila odpoved.
     * @param str
     * @return
     */
    public boolean zpracujPrikaz(String str) {
        if(str == null) {
            return false;
        }
        Matcher m = p.matcher(str);
        if (m.matches()) {
            try {
                String tmp = (m.group(1) == null ) ? m.group(2) : m.group(1);
                Prikaz prikaz = Prikaz.valueOf(tmp);

                return prikaz(prikaz, m);

            } catch (IllegalArgumentException ex) {   //pokud zada spatnej prikaz, ale to by mel osetrit REGEX
                badCommand();
                return true;
            }
        } else {
            badCommand();
            return true;
        }
    }

    /**
     * Zde zavirame pripojeni, pokus se nepodari je nam to jedno. pouze vypiseme vyjimku.
     * nevadi na ani zeto je null, to se taky zachyti. Je to do skoly, ne realnej program
     */
    private void close() {
        try {
            in.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        try {
            out.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        try {
            sok.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private void neniPorucha() {
        out.write("571 NENI PORUCHA ");
        zapisKonecRadku();
    }

    private void zapisKonecRadku() {
        out.write(0x0D);
        out.write(0x0A);
        out.flush();
    }

    private void badCommand() {
        out.print("500 NEZNAMY PRIKAZ ");
        zapisKonecRadku();
    }

    private boolean prikaz(Prikaz prikaz, Matcher m) {
        try {
            Robot r;
            if (prikaz == Prikaz.OPRAVIT) {
                r = mesto.prikaz(prikaz, Integer.valueOf(m.group(3)));
            } else {
                r = mesto.prikaz(prikaz);
            }
            if (r.getTajemstvi() == null) {
                out.print("250 OK (" + r.getBaterie() + "," + r.getX() + "," + r.getY() + ")");
                zapisKonecRadku();
                return true;    //pokracujeme
            } else {
                out.print("221 USPECH " + r.getTajemstvi());
                zapisKonecRadku();
                return false;   //ukoncujeme spojeni
            }
        } catch (OutOfRangeException ex1) {
            out.print("530 HAVARIE");
            zapisKonecRadku();
            return false;
        } catch (ZnackaNenalezena ex2) {
            out.print("550 NELZE ZVEDNOUT ZNACKU");
            zapisKonecRadku();
            return false;
        } catch (NoEnergyException ex3) {
            out.print("540 BATERIE PRAZDNA");
            zapisKonecRadku();
            return false;
        }catch(RobotErrorException ex4) {
            out.print("570 PORUCHA BLOK " + ex4.getCisloBloku());
            zapisKonecRadku();
            return true;
        }catch(RobotCrashException ex5) {
            out.print("572 ROBOT SE ROZPADL");
            zapisKonecRadku();
            return false;
        }catch(NoErrorException ex6) {
            out.print("571 NENI PORUCHA");
            zapisKonecRadku();
            return true;
        }
    }
}
