/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package semestralka;

import java.net.InetAddress;

/**
 *
 * @author Radek Hubner
 */
public class Ezop {

    private KarelClient c = null;

    public Ezop() throws Exception {
        c = new KarelClient(InetAddress.getByName("dsnlab1.felk.cvut.cz"), 3555);
    }

    public String getTajemstvi() throws Exception {

        Robot r1 = c.vlevo();
        Robot r2 = c.krok(r1);
        Smer s = getSmer(r1, r2);



        boolean minusX = (r2.getX() < 0);    //je v minus souradnicich?

        switch (s) {
            case SEVER:
                if (minusX) {
                    c.vpravo();
                } else {
                    c.vlevo();
                }
                break;
            case JIH:
                if (minusX) {
                    c.vlevo();
                } else {
                    c.vpravo();
                }
                break;
            case ZAPAD:
                if (minusX) {
                    c.vlevo();
                    c.vlevo();
                }
                break;
            case VYCHOD:
                if (minusX) {
                    // nic nedelame, natocen jak potrebujem
                } else {
                    c.vlevo();
                    c.vlevo();
                }
                break;
        }
        if (r2.getX() != 0) {
            jdiX();
        }

        if (r2.getY() != 0) {

            boolean minusY = (r2.getY() < 0);
            if (minusX) { //jede na vychod
                if (minusY) {
                    c.vlevo();
                } else {
                    c.vpravo();
                }
            } else { //jede na zapad
                if (minusY) {
                    c.vpravo();
                } else {
                    c.vlevo();
                }
            }
            jdiY();
        }

        String q = c.zvedni();
        c.close();
        return q;
    }

    private void jdiX() {
        Robot r = null;
        do {
            r = c.krok();
        } while (r.getX() != 0);
    }

    private void jdiY() {
        Robot r = null;
        do {
            r = c.krok();
        } while (r.getY() != 0);
    }

    private Smer getSmer(Robot r1, Robot r2) {
        if (r2.getX() - r1.getX() == 0) {    //pouze sever nebo jih
            if (r2.getY() - r1.getY() > 0) {
                return Smer.SEVER;
            } else {
                return Smer.JIH;
            }
        } else {
            if (r2.getX() - r1.getX() > 0) {
                return Smer.VYCHOD;
            } else {
                return Smer.ZAPAD;
            }
        }
    }
}
