/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package semestralka;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author Radek Hubner
 */
public class Odpoved {

    public Odpoved(String msg) {
        Pattern p = Pattern.compile("(\\d\\d\\d) (.+)");
        Matcher m = p.matcher(msg);
        if(m.matches()) {
            this.kod = Integer.valueOf(m.group(1));
            this.msg = m.group(2);
        }else {
            throw new IllegalArgumentException("spatna odpoved od robota");
        }
    }

    public Odpoved(int kod, String msg) {
        this.kod = kod;
        this.msg = msg;
    }

    public int getKod() {
        return kod;
    }

    public String getMsg() {
        return msg;
    }

    private int kod;
    private String msg;

}
