/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package semestralka;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import static java.lang.Math.abs;

/**
 *
 * @author Radek Hubner
 */
public class Robot {

    public Robot(Odpoved o) {
        Pattern p = Pattern.compile("^OK \\((\\d{1,3}),(\\-?\\d{1,2}),(\\-?\\d{1,2})\\).*");
        Matcher m = p.matcher(o.getMsg());
        if (m.matches()) {
            baterie = Integer.valueOf(m.group(1));
            x = Integer.valueOf(m.group(2));
            y = Integer.valueOf(m.group(3));

        } else {
            throw new IllegalArgumentException("chybne parametry polohy robota");
        }
    }
    private int x;
    private int y;
    private int baterie;
    private String tajemstvi;

    public Robot(int x, int y, int baterie) throws OutOfRangeException {
        this.x = x;
        this.y = y;

        if (abs(x) > 17 || abs(y) > 17) {
            throw new OutOfRangeException("robot vyjel mimo drahu");
        }
        if (baterie < 0) {
            throw new NoEnergyException();
        } else {
            this.baterie = baterie;
        }

    }

    public Robot(String tajemstvi) {
        this.tajemstvi = tajemstvi;
    }

    public String getTajemstvi() {
        return tajemstvi;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }

    public int getBaterie() {
        return baterie;
    }

    @Override
    public String toString() {
        return "Robot{" + "x=" + x + "y=" + y + "baterie=" + baterie + '}';
    }

    /**
     * porovnava pouze polohu
     * @param obj
     * @return
     */
    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Robot other = (Robot) obj;
        if (this.x != other.x) {
            return false;
        }
        if (this.y != other.y) {
            return false;
        }
        return true;
    }
}
